% RTS signal parameter
close all
clear all
% Reference RTS Signal
Max_length = 2e5;
Amplitude = 100; %200
Pedestal =10;
RTS_A_levels = [Pedestal Pedestal+Amplitude];
RTS_A_tau_up =100; %1000
RTS_A_tau_down = 100;
imax=round(5e6*1/(RTS_A_tau_up+RTS_A_tau_down));
RTS_A_Time_Up=round(exprnd(RTS_A_tau_up,1,imax));
RTS_A_Time_down=round(exprnd(RTS_A_tau_down,1,imax));
RTS_A_Signal=[];

RTS_state=1;
i=1;
while length(RTS_A_Signal)<Max_length
    if RTS_state==1
        RTS_A_Signal=[RTS_A_Signal , ones(1,RTS_A_Time_down(i))*RTS_A_levels(RTS_state)];
        RTS_state=2;
    else
        RTS_A_Signal=[RTS_A_Signal, ones(1,RTS_A_Time_Up(i))*RTS_A_levels(RTS_state)];
        RTS_state=1;
    end
    i=i+1;
end

RTS_A_Signal = RTS_A_Signal(1:Max_length);
length(RTS_A_Signal)

S=RTS_A_Signal;

% FFT calculation and display
Fs = 1;            % Sampling frequency                    
T = 1/Fs;             % Sampling period       
L = length(S);             % Length of signal
t = (0:L-1)*T;        % Time vector
%X = S + 0.5*randn(size(t)); %add white noise
X=S;
figure
plot(X)
%axis([0 0.1*length(X) 0 1.2*max(X)])
axis([0 2e5 0 1.2*max(X)])

% Compute the FFT
Y = fft(X);

% Compute the one sided FFT
P2 = abs(Y/L);
P1 = P2(1:L/2+1);
P1(2:end-1) = 2*P1(2:end-1);
f = Fs*(0:(L/2))/L;

%Compute the one sided PSD
P1 = P1.*P1;

    F_spectrum=figure;
    %loglog(f,movmean(P1,10)) 
    loglog(f,P1) 
    title('Influence of Tlong - PSD')
    xlabel('f (Hz)')
    ylabel('PSD (V²/Hz)')
    axis([1e-5 0.5 1e-7 100])

%% Additionnal RTS signal for comparison: 10000/100
Max_length = 2e5;
Amplitude = 100; %200
Pedestal =10;
RTS_A_levels = [Pedestal Pedestal+Amplitude];
RTS_A_tau_up =10000; %1000
RTS_A_tau_down = 100;
imax=round(5e6*1/(RTS_A_tau_up+RTS_A_tau_down));
RTS_A_Time_Up=round(exprnd(RTS_A_tau_up,1,imax));
RTS_A_Time_down=round(exprnd(RTS_A_tau_down,1,imax));
RTS_A_Signal=[];

RTS_state=1;
i=1;
while length(RTS_A_Signal)<Max_length
    if RTS_state==1
        RTS_A_Signal=[RTS_A_Signal , ones(1,RTS_A_Time_down(i))*RTS_A_levels(RTS_state)];
        RTS_state=2;
    else
        RTS_A_Signal=[RTS_A_Signal, ones(1,RTS_A_Time_Up(i))*RTS_A_levels(RTS_state)];
        RTS_state=1;
    end
    i=i+1;
end

RTS_A_Signal = RTS_A_Signal(1:Max_length);
length(RTS_A_Signal)

S=RTS_A_Signal;

% FFT calculation and display
Fs = 1;            % Sampling frequency                    
T = 1/Fs;             % Sampling period       
L = length(S);             % Length of signal
t = (0:L-1)*T;        % Time vector
%X = S + 0.5*randn(size(t)); %add white noise
X=S;
figure
plot(X)
%axis([0 length(X) 0 1.2*max(X)])
axis([0 2e5 0 1.2*max(X)])


% Compute the FFT
Y = fft(X);

% Compute the one sided FFT
P2 = abs(Y/L);
P1 = P2(1:L/2+1);
P1(2:end-1) = 2*P1(2:end-1);
f = Fs*(0:(L/2))/L;

%Compute the one sided PSD
P1 = P1.*P1;

figure(F_spectrum)
hold on
loglog(f,P1) 



